summaryrefslogtreecommitdiff
path: root/tests/du/inacc-dir.sh
diff options
context:
space:
mode:
Diffstat (limited to 'tests/du/inacc-dir.sh')
-rwxr-xr-xtests/du/inacc-dir.sh42
1 files changed, 42 insertions, 0 deletions
diff --git a/tests/du/inacc-dir.sh b/tests/du/inacc-dir.sh
new file mode 100755
index 000000000..8395c56e8
--- /dev/null
+++ b/tests/du/inacc-dir.sh
@@ -0,0 +1,42 @@
+#!/bin/sh
+# Ensure that du counts the size of an inaccessible directory.
+# Copyright (C) 2007-2012 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ du
+skip_if_root_
+
+mkdir -p a/sub || framework_failure_
+
+
+du -s a > exp || fail=1
+chmod 0 a/sub || fail=1
+# Expect failure, ignore diagnostics.
+du -s a > out 2> /dev/null && fail=1
+
+compare exp out || fail=1
+
+# Same as above, but don't use -s, so we print
+# an entry for the unreadable "sub", too.
+chmod 700 a/sub || fail=1
+du -k a > exp || fail=1
+chmod 0 a/sub || fail=1
+# Expect failure, ignore diagnostics.
+du -k a > out 2> /dev/null && fail=1
+
+compare exp out || fail=1
+
+Exit $fail